Produce output

>module Compile (makeOutput,dispIntermediare) where

>import Useful
>import Pprint
>import Atoms
>import Messages
>import Types

>import CompileRun
>import DispInter

>makeOutput :: String -> String -> String -> ExternalList -> InputOLD -> String -> String
>makeOutput conts version who external2 
>           (fvts, fnts, fiks, dtdefs, procs, protdesc,_,_,
>            _,_,_,inlines,_,_,_,_,_,_,_,_,_,_,_) hash =
>	    let external = (couple external2) in
>	    let ks=(inside "KeyStore" [x|(a,x)<-external]) in
>	    let sks=(inside "File" [x|(a,x)<-external]) in
>	    let id=(idFromProcs who procs) in
>	    let knowns=(knownsFromProcs who procs) in
>	    let comms=(lstComm protdesc) in
>	    let protdesc2=(purgeProtdesc id protdesc) in
>	    let initie=(initier protdesc2 comms) in
>	    let tc=(toContact id procs) in
>	    let nbargs1=if (ks) then 2 else 0 in
>	    let nbargs2=if (sks) then 1 else 0 in
>	    let nbargs=nbargs1+nbargs2+(length tc)+(length knowns) in
>	    "package protocols;\n\n"++
>	    "import core.*;\n"++
>	    "import java.io.BufferedReader;\n"++
>	    "import java.io.InputStreamReader;\n"++
>	    "import java.lang.reflect.Array;\n"++
>	    "import java.io.ObjectOutputStream;\n"++
>	    "import java.io.ByteArrayOutputStream;\n"++
>	    "import java.math.BigInteger;\n\n"++

>	    "public class "++who++" extends Protocol {\n\n"++

>	    (if (protoTag==True) then "static String protoTag=\""++hash++"\";\n\n"
>	      else "")++

>	    "public "++who++" (ObjectOutputStream oos) {\n"++
>	    (if tag == True then "super(\"core.MessageT\",\"core.MessageKeyT\",\"core.NonceT\");" else
>		                 "super(\"core.Message\" ,\"core.MessageKey\" ,\"core.Nonce\" );")++
>	    "\nthis.oos=oos;\n}\n\n"++

>	    "public void run() {\ntry {\n"++
>	    (createRef fvts)++"\n"++(createNodes fvts id procs)++"\n"++
>	    (makeRun id fvts fnts protdesc2 comms)++ --(makeResult fvts)++
>	    "\n} catch (Exception e) {e.printStackTrace();System.exit(0);}\n}\n\n"++

>	    "public static void subMain(String[] args,ObjectOutputStream oos) {\n"++
>	    (if (isInit id protdesc) then 
>	      (who++" "++id++" = new "++who++"(oos);\n"++
>	      "args="++id++".getArgs(args);\n"++
>	      id++".start();\n") 
>	    else who++" "++id++";\n"++
>	      "while (true) {\n"++id++"=new "++who++"(oos);\n"++
>	      "args="++id++".getArgs(args);\n"++
>	      --"println(\"New thread created; waiting for a connection\");\n"++
>	      id++".newAgent(\""++(fst initie)++"\","++(show (4000+(snd initie)))++");\n"++id++".start();\n}\n")++
>	    "}\n\n"++

>	    "public String[] getArgs(String[] args) {\n"++
>	    "try {\n"++
>	    "if (args.length != "++(show nbargs)++") {\n"++
>	    "args = (String[]) Array.newInstance(\"\".getClass(), "++(show nbargs)++");\n"++
>	    "BufferedReader in2 =\n"++
>	    "new BufferedReader(new InputStreamReader(System.in));\n"++
>	    (if (ks) then 
>	    	(argQuery "Type the KeyStore file to use " "keystore" "0")++
>	    	(argQuery "Type the password to access it" "duitama" "1")
>		else "")++
>	    (if (sks) then 
>		(argQuery "Type the SecretKeyStore file to use" "secretkeystore" (show nbargs1))
>		else "")++
>	    (stringToContact False tc (toInteger (nbargs1+nbargs2)))++
>	    (stringKnown False knowns (toInteger (nbargs1+nbargs2+(length tc))))++
>	    "}\n"++
>	    (if (ks) then
>		"setKS(args[0],args[1]);\n"
>		else "")++
>	    (if (sks) then 
>		"setSKS(args["++(show nbargs1)++"]);\n"
>		else "")++
>	    (stringToContact True tc (toInteger (nbargs1+nbargs2)))++
>	    (stringKnown True knowns (toInteger (nbargs1+nbargs2+(length tc))))++
>	    "} catch (Exception e) {e.printStackTrace();}\n"++
>	    "return args;\n}\n\n"++
>	    "public static void main(String[] args) {\n"++
>	    "ObjectOutputStream oos=null;\n"++
>	    "try {\n"++
>	    "ByteArrayOutputStream os = new ByteArrayOutputStream();\n"++
>	    "oos=new ObjectOutputStream(os);\n"++
>	    "PrintOOS p=new PrintOOS(\""++who++"\",oos,os);\n"++
>	    "p.start();}\n"++
>	    "catch (Exception e) {e.printStackTrace();}\n"++
>	    "subMain(args,oos);\n"++
>	    "}\n"++
>	    "}"

>createRef :: VarTypeList -> String
>createRef [] = ""
>createRef ((a,b):q) =  --if (b=="Nonce") then "Nonce "++a++" = null;\n"++(createRef q) else
>	(if (b=="DESKey") then "IMessageKey "++a++" = null;\n"
>	else if (b=="BigInteger") then "BigInteger "++a++" = null;\n"
>	else "")++(createRef q)

>idFromProcs :: String -> ProcessList -> String
>idFromProcs who [] = "" 
>idFromProcs who ((a,b,c,d,e):q) = (if (b==who) then a else (idFromProcs who q))

>knownsFromProcs :: String -> ProcessList -> [String]
>knownsFromProcs who [] = [] 
>knownsFromProcs who ((a,b,c,d,e):q) = (if (b==who) then c else (knownsFromProcs who q))

>purgeProtdesc :: String -> ProtDesc -> ProtDesc
>purgeProtdesc id [] = []
>purgeProtdesc id ((a,b,Agent c,x,e,f):q) = if (c==id || x==Agent id) 
>	then ((a,b,Agent c,x,e,f):(purgeProtdesc id q))
>	else (purgeProtdesc id q)
>purgeProtdesc id ((a,b,x,Agent c,e,f):q) = if (c==id) 
>	then ((a,b,x,Agent c,e,f):(purgeProtdesc id q))
>	else (purgeProtdesc id q)
>purgeProtdesc id (_:q) = (purgeProtdesc id q)

>argQuery :: String -> String -> String -> String
>argQuery query defaut nb=
>	    "println(\""++query++" ["++defaut++"]\");\n"++
>	    "args["++nb++"]=in2.readLine();\n"++
>	    "if (args["++nb++"].compareTo(\"\")==0) args["++nb++"]=\""++defaut++"\";\n"

>toContact :: String -> ProcessList -> [String]
>toContact who [] = []
>toContact who ((a,b,c,d,e):q) = if (who==a) then (filter (/=who) c)
>				else (toContact who q)

>stringToContact :: Bool -> [String] -> Integer -> String
>stringToContact _ [] _ = ""
>stringToContact b (t:q) n = (if b==False then 
>	(argQuery ("Type the DNS name of agent "++t) "localhost" (show n)) else
>	"setIPToId(args["++(show n)++"],\""++t++"\");\n")++
>	(stringToContact b q (n+1))

>stringKnown :: Bool -> [String] -> Integer -> String
>stringKnown _ [] _ = ""
>stringKnown b (t:q) n = (if b==False then 
>	(argQuery ("Type the name of agent "++t) t (show n)) else 
>	"setNameToId(args["++(show n)++"],\""++t++"\");\n")++
>	(stringKnown b q (n+1))

>isInit :: String -> ProtDesc -> Bool
>isInit id ((_,_,Agent a,_,_,_):_) = if (a==id) then True else False
>isInit id _ = False

>initier :: ProtDesc -> [String] -> (String,Integer)
>initier ((_,nb,Agent a,_,_,_):_) x = (a,(rang nb x))

>inside :: (Eq a) => a -> [a] -> Bool
>inside a [] = False
>inside a (t:q) = if (a==t) then True else (inside a q)

>lstComm :: ProtDesc -> [String]
>lstComm l = [x|(x,y,z)<-(lstComm2 l)]

>lstComm2 :: ProtDesc -> [(String,String,String)]
>lstComm2 [] = []
>lstComm2 ((_,nb,Agent a,Agent b,_,_):q) = addComm (nb,a,b) (lstComm2 q)
>lstComm2 (_:q) = lstComm2 q


>addComm :: (String,String,String) -> [(String,String,String)] -> [(String,String,String)]
>addComm (nb,a,b) [] = [(nb,a,b)]
>addComm (nb,a,b) ((nb2,c,d):q)=if (a==c && b==d) || (a==d && b==c) then ((nb,a,b):q)
>	else (nb2,c,d):(addComm (nb,a,b) q)

