package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITYAHA extends Protocol {
   
   public INITYAHA (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         IMessageKey kab = null;
         
         println("creating nonce na");
         createNewNonce("na");
         
         println("Building message m1");
         Message m1 =message();
         m1.addMessage(message(agentFromId("a")));
         m1.addMessage(message(nonceFromId("na")));
         println("Sending message m1");
         put("b", m1.getString(),4000);
         
         println("waiting for m3a");
         Message m3a = message(get("s",4002));
         println("Decrypting m3a");
         m3a.decrypt("DES", getSecretKey(nameFromId("a")));
         addParts(m3a.getAllFields(),4);
         m0=getPart();
         setNameToId(m0.getString(),"b");
         m0=getPart();
         kab= messageKey(m0);
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         println("Building message m4");
         Message m4 =message();
         m4.addMessage(message(nonceFromId("nb")));
         println("Encrypting m4");
         m4.encrypt("DES", kab.toKey());
         println("Sending message m4");
         put("b", m4.getString());
         
         writeObject(nameFromId("b"));
         writeObject(kab.getString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITYAHA a = new INITYAHA(oos);
      args=a.getArgs(args);
      a.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 4) {
            args = (String[]) Array.newInstance("".getClass(), 4);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the SecretKeyStore file to use [secretkeystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="secretkeystore";
            println("Type the DNS name of agent b [localhost]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="localhost";
            println("Type the name of agent a [a]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="a";
            println("Type the name of agent b [b]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="b";
            }
         setSKS(args[0]);
         setIPToId(args[1],"b");
         setNameToId(args[2],"a");
         setNameToId(args[3],"b");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITYAHA",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }