package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class SERVYAHA extends Protocol {
   
   public SERVYAHA (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         IMessageKey kab = null;
         
         println("creating DESkey kab");
         kab = messageKey("DES");
         
         println("waiting for m2");
         Message m2 = message(get("b",4001));
         addParts(m2.getAllFields(),2);
         m0=getPart();
         setNameToId(m0.getString(),"b");
         m0=getPart();
         println("Decrypting m0");
         m0.decrypt("DES", getSecretKey(nameFromId("b")));
         addParts(m0.getAllFields(),4);
         m0=getPart();
         setNameToId(m0.getString(),"a");
         m0=getPart();
         setIPToId(m0.getString(),"a");
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         
         println("Building message m3a");
         Message m3a =message();
         m3a.addMessage(message(agentFromId("b")));
         m3a.addMessage(message(kab.getString()));
         m3a.addMessage(message(nonceFromId("na")));
         m3a.addMessage(message(nonceFromId("nb")));
         println("Encrypting m3a");
         m3a.encrypt("DES", getSecretKey(nameFromId("a")));
         println("Sending message m3a");
         put("a", m3a.getString(),4002);
         
         println("Building message m3b");
         Message m3b =message();
         m3b.addMessage(message(agentFromId("a")));
         m3b.addMessage(message(kab.getString()));
         println("Encrypting m3b");
         m3b.encrypt("DES", getSecretKey(nameFromId("b")));
         println("Sending message m3b");
         put("b", m3b.getString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      SERVYAHA s;
      while (true) {
         s=new SERVYAHA(oos);
         args=s.getArgs(args);
         s.newAgent("b",4001);
         s.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 2) {
            args = (String[]) Array.newInstance("".getClass(), 2);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the SecretKeyStore file to use [secretkeystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="secretkeystore";
            println("Type the name of agent s [s]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="s";
            }
         setSKS(args[0]);
         setNameToId(args[1],"s");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("SERVYAHA",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }